package F5::ProtocolBuffers;

use strict;
use warnings;

use Google::ProtocolBuffers::Dynamic;
use File::Find;
use File::Basename;
use File::Spec;

#----------------------------------------------------------------------

sub init {
    my(%params) = @_;
    my $base_dir = $params{base_dir};
    my $package = $params{package};
    my $prefix = $params{prefix};

    my $p = Google::ProtocolBuffers::Dynamic->new($base_dir);

    find({
          no_chdir => 1,
          wanted => sub {
              my $filename = basename($File::Find::name);
              if (-f $File::Find::name && $filename =~ /\.proto$/) {
                  my $relative_path = File::Spec->abs2rel($File::Find::name, $base_dir);
                  $p->load_file($relative_path);
                  if ($relative_path =~ /google\/protobuf/) {
                     $p->map({package => "google.protobuf", prefix => "google.protobuf"});
                  }
              }
          },
         },
         $base_dir);

    $p->map({package => $package, prefix => $prefix});
}

#----------------------------------------------------------------------

1;
